function  G = Gauss1( sigma )
%Return a vector with a discretization of the Gauss function at scale sigma

% A factor of 2.5 creates vectors of appropriate size
M=2.5 * sigma;

% create appropriate ranges for x
x = -M:M;

% create a sampling grid
X = meshgrid(x, 1);

e=exp(1);      %2.71828

% calculate the Gaussian function
G = 1 / ((sqrt(2*pi)*sigma)^1);
G = G * e.^((X.^2) / (-2*sigma^2));
