function result = camera(points, u, phi, translation, f)
%project a 3d scene (points) in 2d, according to camera position (translation)
%and angle (phi).
Mint = [ f, 0, 0, 0; 0, f, 0, 0 ; 0, 0, 1, 0]

r = [ 1+(1-cos(phi))*(u(1)^2-1), ...
     (1-cos(phi))*u(1)*u(2)-u(3)*sin(phi),...
     (1-cos(phi))*u(1)*u(3)+u(2)*sin(phi);...
     ...
     (1-cos(phi))*u(1)*u(2)+u(3)*sin(phi), ...
     1+(1-cos(phi))*(u(2)^2-1), ...
     (1-cos(phi))*u(2)*u(3)-u(1)*sin(phi); ...
     ...
     (1-cos(phi))*u(1)*u(3)-u(2)*sin(phi), ...
     (1-cos(phi))*u(2)*u(3)+u(1)*sin(phi), ...
     1+(1-cos(phi))*(u(3)^2-1)]


Mext = [r, translation; 0,0,0,1]

result = (Mint * Mext) * [points; ones(1, size(points, 2))];

mask = 1-(result(3,:) == 0);
result = result .* [mask;mask;mask];

result = [result(1,:) ./ result(3,:); result(2,:) ./ result(3,:)]
