function M = estimateProjectionMatrix(xy, XYZ)
%linear approximation of projection matrix, given a set of 2d points (xy)
%and corresponding 3d points (XYZ)

% calculation of projection matrix
x = xy(:,1);
y = xy(:,2);

% we cannot use x' and y' in Matlab because ' means transposed
X = XYZ(:,1);
Y = XYZ(:,2);
Z = XYZ(:,3);

o = ones(size(x));
z = zeros(size(x));
Aoddrows =  [X, Y, Z, o, z, z, z, z, -x.*X, -x.*Y, -x.*Z, -x];
Aevenrows = [z, z, z, z, X, Y, Z, o, -y.*X, -y.*Y, -y.*Z, -y];
A = [ Aoddrows ; Aevenrows ];

% Do Singular Value Decomposition to obtain m
[U, D, V] = svd(A);

m = V(:, end );

% reshape m into the 3x3 projection matrix M
M = reshape(m, 4, 3)';
