function H = houghTransform(image, dim)
%Apply hough transform on a grayscale image and return its hough space
%(after which a cluster algorithm should be applied)

tic
sigma = 1.5;

% apply Canny edge detector
cannyEdges = canny(image, sigma);
%cannyEdges = canny(rgb2gray(image), sigma);
toc

% (do not) apply thresholding
threshHoldedImage = (cannyEdges > 0.1) .* cannyEdges;

tic
% perform Hough transformation

%indices of non-zero elements (ie. trace edges)
[X, Y] = find(threshHoldedImage);

%size of discretized hough space
H = zeros(dim+1);
rmax = norm(size(threshHoldedImage));

%this would be fast, but doesn't seem to work
%H = sum(decaySineCurve(X, Y, rmax, dim, dim));
iterations=size(X,1)
for a = 1:size(X)
    H = H + (decaySineCurve(X(a), Y(a), rmax, dim, dim));
    %H = H + (slowSineDecay(X(a), Y(a), rmax, dim, dim));
end
toc

% retain a window with an interval of pi/4:3*pi/4
% since the sine curve is periodic
H = H(:, dim/4+10:3*dim/4+10);
